package com.domemusictechnologies.tpdfnoise;


import voltage.controllers.*;
import voltage.core.*;
import voltage.core.Jack.JackType;
import voltage.sources.*;
import voltage.utility.*;
import voltage.processors.*;
import voltage.effects.*;
import java.awt.*;

//[user-imports]   Add your own imports here
//[/user-imports]


public class TPDFNoise extends VoltageModule
//[user-inheritance]
//[/user-inheritance]
{

public TPDFNoise( long moduleID, VoltageObjects voltageObjects )
{
   super( moduleID, voltageObjects, "TPDF Noise", ModuleType.ModuleType_Source, 1.0 );

   InitializeControls();


   canBeBypassed = true;
   SetSkin( "87f0d2abaf394d4fbc07f4dd06ac5ee5" );
}

void InitializeControls()
{

   textLabel1 = new VoltageLabel( "textLabel1", "textLabel1", this, "Dome Music    Technologies" );
   AddComponent( textLabel1 );
   textLabel1.SetWantsMouseNotifications( false );
   textLabel1.SetPosition( 14, 338 );
   textLabel1.SetSize( 45, 25 );
   textLabel1.SetEditable( false, false );
   textLabel1.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel1.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel1.SetColor( new Color( 255, 255, 255, 255 ) );
   textLabel1.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel1.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel1.SetBorderSize( 1 );
   textLabel1.SetMultiLineEdit( true );
   textLabel1.SetIsNumberEditor( false );
   textLabel1.SetNumberEditorRange( 0, 100 );
   textLabel1.SetNumberEditorInterval( 1 );
   textLabel1.SetNumberEditorUsesMouseWheel( false );
   textLabel1.SetHasCustomTextHoverColor( false );
   textLabel1.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel1.SetFont( "Verdana", 8, false, false );

   textLabel2 = new VoltageLabel( "textLabel2", "textLabel2", this, "TPDF Noise" );
   AddComponent( textLabel2 );
   textLabel2.SetWantsMouseNotifications( false );
   textLabel2.SetPosition( 6, 0 );
   textLabel2.SetSize( 61, 31 );
   textLabel2.SetEditable( false, false );
   textLabel2.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel2.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel2.SetColor( new Color( 255, 255, 255, 255 ) );
   textLabel2.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel2.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel2.SetBorderSize( 1 );
   textLabel2.SetMultiLineEdit( true );
   textLabel2.SetIsNumberEditor( false );
   textLabel2.SetNumberEditorRange( 0, 100 );
   textLabel2.SetNumberEditorInterval( 1 );
   textLabel2.SetNumberEditorUsesMouseWheel( false );
   textLabel2.SetHasCustomTextHoverColor( false );
   textLabel2.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel2.SetFont( "Verdana", 14, false, false );

   switchTPDF = new VoltageSwitch( "Probability Distribution", "Probability Distribution", this, 1 );
   AddComponent( switchTPDF );
   switchTPDF.SetWantsMouseNotifications( false );
   switchTPDF.SetPosition( 15, 176 );
   switchTPDF.SetSize( 35, 35 );
   switchTPDF.SetSkin( "2-State Bar Horizontal" );

   outputJackWhite = new VoltageAudioJack( "White Noise Output", "White Noise Output", this, JackType.JackType_AudioOutput );
   AddComponent( outputJackWhite );
   outputJackWhite.SetWantsMouseNotifications( false );
   outputJackWhite.SetPosition( 21, 120 );
   outputJackWhite.SetSize( 25, 25 );
   outputJackWhite.SetSkin( "Jack Round White Ring" );

   textLabel3 = new VoltageLabel( "textLabel3", "textLabel3", this, "White" );
   AddComponent( textLabel3 );
   textLabel3.SetWantsMouseNotifications( false );
   textLabel3.SetPosition( 19, 101 );
   textLabel3.SetSize( 36, 19 );
   textLabel3.SetEditable( false, false );
   textLabel3.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel3.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel3.SetColor( new Color( 255, 255, 255, 255 ) );
   textLabel3.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel3.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel3.SetBorderSize( 1 );
   textLabel3.SetMultiLineEdit( false );
   textLabel3.SetIsNumberEditor( false );
   textLabel3.SetNumberEditorRange( 0, 100 );
   textLabel3.SetNumberEditorInterval( 1 );
   textLabel3.SetNumberEditorUsesMouseWheel( false );
   textLabel3.SetHasCustomTextHoverColor( false );
   textLabel3.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel3.SetFont( "Verdana", 12, false, false );

   outputJackBlue = new VoltageAudioJack( "Blue Noise Output", "Blue Noise Output", this, JackType.JackType_AudioOutput );
   AddComponent( outputJackBlue );
   outputJackBlue.SetWantsMouseNotifications( false );
   outputJackBlue.SetPosition( 21, 240 );
   outputJackBlue.SetSize( 25, 25 );
   outputJackBlue.SetSkin( "Jack Round Sky Ring" );

   textLabel4 = new VoltageLabel( "textLabel4", "textLabel4", this, "Blue" );
   AddComponent( textLabel4 );
   textLabel4.SetWantsMouseNotifications( false );
   textLabel4.SetPosition( 22, 265 );
   textLabel4.SetSize( 30, 19 );
   textLabel4.SetEditable( false, false );
   textLabel4.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel4.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel4.SetColor( new Color( 255, 255, 255, 255 ) );
   textLabel4.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel4.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel4.SetBorderSize( 1 );
   textLabel4.SetMultiLineEdit( false );
   textLabel4.SetIsNumberEditor( false );
   textLabel4.SetNumberEditorRange( 0, 100 );
   textLabel4.SetNumberEditorInterval( 1 );
   textLabel4.SetNumberEditorUsesMouseWheel( false );
   textLabel4.SetHasCustomTextHoverColor( false );
   textLabel4.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel4.SetFont( "Verdana", 12, false, false );

   curve1 = new VoltageCurve( "curve1", "curve1", this );
   AddComponent( curve1 );
   curve1.SetWantsMouseNotifications( false );
   curve1.SetPosition( 39, 213 );
   curve1.SetSize( 16, 16 );
   curve1.SetRange( (float)0.0, (float)1.0 );
   curve1.SetStartValue( (float)0.0 );
   curve1.SetEndValue( (float)1.0 );
   curve1.SetControlPoint1( (float)0.95, (float)0.00 );
   curve1.SetControlPoint2( (float)0.30, (float)1.00 );
   curve1.SetCurveThickness( (float)2.0 );
   curve1.SetBorderSize( (float)1.0 );
   curve1.SetHasRoundedCorners( true );
   curve1.SetCurveType( VoltageCurve.CurveType.Cubic );
   curve1.SetControlPoint1EditType( VoltageCurve.ControlPt1EditType.BothXAndYEditable );
   curve1.SetBackgroundColor( new Color( 0, 0, 0, 0), VoltageCurve.MouseState.ALL_Mouse_States );
   curve1.SetCurveColor( new Color( 255, 255, 255, 255), VoltageCurve.MouseState.ALL_Mouse_States );
   curve1.SetBorderColor( new Color( 0, 0, 0, 0), VoltageCurve.MouseState.ALL_Mouse_States );
   curve1.SetDottedLineColor( new Color( 0, 0, 0, 0), VoltageCurve.MouseState.ALL_Mouse_States );
   curve1.SetEditable( false );
   curve1.SetHorizontal( true );

   curve2 = new VoltageCurve( "curve2", "curve2", this );
   AddComponent( curve2 );
   curve2.SetWantsMouseNotifications( false );
   curve2.SetPosition( 50, 213 );
   curve2.SetSize( 16, 16 );
   curve2.SetRange( (float)0.0, (float)1.0 );
   curve2.SetStartValue( (float)1.0 );
   curve2.SetEndValue( (float)0.0 );
   curve2.SetControlPoint1( (float)0.70, (float)1.00 );
   curve2.SetControlPoint2( (float)0.05, (float)0.00 );
   curve2.SetCurveThickness( (float)2.0 );
   curve2.SetBorderSize( (float)1.0 );
   curve2.SetHasRoundedCorners( true );
   curve2.SetCurveType( VoltageCurve.CurveType.Cubic );
   curve2.SetControlPoint1EditType( VoltageCurve.ControlPt1EditType.BothXAndYEditable );
   curve2.SetBackgroundColor( new Color( 45, 55, 65, 0), VoltageCurve.MouseState.ALL_Mouse_States );
   curve2.SetCurveColor( new Color( 255, 255, 255, 255), VoltageCurve.MouseState.ALL_Mouse_States );
   curve2.SetBorderColor( new Color( 0, 0, 0, 0), VoltageCurve.MouseState.ALL_Mouse_States );
   curve2.SetDottedLineColor( new Color( 0, 0, 0, 0), VoltageCurve.MouseState.ALL_Mouse_States );
   curve2.SetEditable( false );
   curve2.SetHorizontal( true );
}



//-------------------------------------------------------------------------------
//  public void Initialize()

//  Initialize will get called shortly after your module's constructor runs. You can use it to
//  do any initialization that the auto-generated code doesn't handle.
//-------------------------------------------------------------------------------
@Override
public void Initialize()
{
   //[user-Initialize]   Add your own initialization code here

   ReadDensityFunctionSwitch (switchTPDF.GetValue());
   
   previousBlueNoise = 0.0;

   //[/user-Initialize]
}


//-------------------------------------------------------------------------------
//  public void Destroy()

//  Destroy will get called just before your module gets deleted. You can use it to perform any
//  cleanup that's not handled automatically by Java.
//-------------------------------------------------------------------------------
@Override
public void Destroy()
{
   super.Destroy();
   //[user-Destroy]   Add your own module-getting-deleted code here



   //[/user-Destroy]
}


//-------------------------------------------------------------------------------
//  public boolean Notify( VoltageComponent component, ModuleNotifications notification, double doubleValue, long longValue, int x, int y, Object object )

//  Notify will get called when various events occur - control values changing, timers firing, etc.
//-------------------------------------------------------------------------------
@Override
public boolean Notify( VoltageComponent component, ModuleNotifications notification, double doubleValue, long longValue, int x, int y, Object object )
{
   //[user-Notify]   Add your own notification handling code between this line and the notify-close comment
   switch( notification )
   {
      case Knob_Changed:   // doubleValue is the new VoltageKnob value
      {
      }
      break;
   
      case Slider_Changed:   // doubleValue is the new slider value
      {
      }
      break;
   
      case Button_Changed:   // doubleValue is the new button/toggle button value
      {
      }
      break;
   
      case Switch_Changed:   // doubleValue is the new switch value
      {
         if (component == switchTPDF)
         {
            ReadDensityFunctionSwitch (doubleValue);
         }
         
      }
      break;
   
      case Jack_Connected:   // longValue is the new cable ID
      {
      }
      break;
   
      case Jack_Disconnected:   // All cables have been disconnected from this jack
      {
      }
      break;
   
      case GUI_Update_Timer:   // Called every 50ms (by default) if turned on
      {
      }
      break;
   
      case Object_MouseMove:   // called when mouse is over an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_MouseLeave:  // called when mouse leaves an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_LeftButtonDown:   // called when user left-clicks on an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_LeftButtonUp:   // called when user releases left mouse button on an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_RightButtonDown:   // called when user releases right mouse button on an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_RightButtonUp:   // called when user right-clicks on an object that receives mouse notifications
      {
      }
      break;
   
      case Object_LeftButtonDoubleClick: // called when user left-button double-clicks on an object that receives mouse notifications
      {
      }
      break;
   
      // Less common notifications:
   
      case Named_Timer:   // object contains a String with the name of the timer that has fired
      {
      }
      break;
   
      case Canvas_Painting:   // About to paint canvas.  object is a java.awt.Rectangle with painting boundaries
      {
      }
      break;
   
      case Canvas_Painted:   // Canvas painting is complete
      {
      }
      break;
   
      case Control_DragStart:    // A user has started dragging on a control that has been marked as draggable
      {
      }
      break;
   
      case Control_DragOn:       // This control has been dragged over during a drag operation. object contains the dragged object
      {
      }
      break;
   
      case Control_DragOff:      // This control has been dragged over during a drag operation. object contains the dragged object
      {
      }
      break;
   
      case Control_DragEnd:      // A user has ended their drag on a control that has been marked as draggable
      {
      }
      break;
   
      case Label_Changed:        // The text of an editable text control has changed
      {
      }
      break;
   
      case SoundPlayback_Start:   // A sound has begun playback
      {
      }
      break;
   
      case SoundPlayback_End:     // A sound has ended playback
      {
      }
      break;
   
      case Scrollbar_Position:    // longValue is the new scrollbar position
      {
      }
      break;
   
      case PolyVoices_Changed:    // longValue is the new number of poly voices
      {
      }
      break;
   
      case File_Dropped:     // 'object' is a String containing the file path
      {
      }
      break;
   
      case Preset_Loading_Start:   // called when preset loading begins
      {
      }
      break;
   
      case Preset_Loading_Finish:  // called when preset loading finishes
      {
      }
      break;
   
      case Variation_Loading_Start:    // sent when a variation is about to load
      {
      }
      break;
   
      case Variation_Loading_Finish:   // sent when a variation has just finished loading
      {
      }
      break;
   
      case Tempo_Changed:     // doubleValue is the new tempo
      {
      }
      break;
   
      case Randomized:     // called when the module's controls get randomized
      {
      }
      break;
   
      case VariationListChanged:   // sent when a variation gets added, deleted, or renamed, or the variations list gets reordered
      {
      }
      break;
   
      case Key_Press:     // sent when module has keyboard focus and a key is pressed; object is a VoltageKeyPressInfo object
      {
      }
      break;
   
      case Reset:    // sent when the module has been reset to default settings
      {
      }
      break;
   
      case Keyboard_NoteOn:   // sent when a note has been pressed on a VoltageKeyboard object. longValue is the note value ( 0-127 )
      {
      }
      break;
   
      case Keyboard_NoteOff:   // sent when a note has been released on a VoltageKeyboard object. longValue is the note value ( 0-127 )
      {
      }
      break;
   
      case Curve_Changed:   // sent when user has edited a curve's value. 'object' will be a VoltageCurve.CurveChangeNotification object.
      {
      }
      break;
   }



   return false;
   //[/user-Notify]
}


//-------------------------------------------------------------------------------
//  public void ProcessSample()

//  ProcessSample is called once per sample. Usually it's where you read
//  from input jacks, process audio, and write it to your output jacks.
//  Since ProcesssSample gets called 48,000 times per second, offload CPU-intensive operations
//  to other threads when possible and avoid calling native functions.
//-------------------------------------------------------------------------------
@Override
public void ProcessSample()
{
   //[user-ProcessSample]   Add your own process-sampling code here

   double tempDouble;

   // Output White Noise
   outputJackWhite.SetValue(GetTriangularProbabilityDensityFunction());

   // Output Blue Noise
   outputJackBlue.SetValue(GetBlueNoiseValue());

   //[/user-ProcessSample]
}


//-------------------------------------------------------------------------------
//  public void ProcessBypassedSample()

//  ProcessBypassedSample gets called instead of ProcessSample when you've checked the "Can Be Bypassed" box
//  and a user has bypassed your module. If your module processes data from input jacks and then sends it to
//  output jack(s), make ProcessBypassedSample just send the data from the input jacks to the output jacks without
//  processing it.
//-------------------------------------------------------------------------------
@Override
public void ProcessBypassedSample()
{
   //[user-ProcessBypassedSample]   Add your own code here

   outputJackWhite.SetValue(0.0);
   outputJackBlue.SetValue(0.0);

   //[/user-ProcessBypassedSample]
}


//-------------------------------------------------------------------------------
//  public String GetTooltipText( VoltageComponent component )

//  Gets called when a tooltip is about to display for a control. Override it if
//  you want to change what the tooltip displays - if you want a knob to work in logarithmic fashion,
//  for instance, you can translate the knob's current value to a log-based string and display it here.
//-------------------------------------------------------------------------------
@Override
public String GetTooltipText( VoltageComponent component )
{
   //[user-GetTooltipText]   Add your own code here



   return super.GetTooltipText( component );
   //[/user-GetTooltipText]
}


//-------------------------------------------------------------------------------
//  public void EditComponentValue( VoltageComponent component, double newValue, String newText )

//  Gets called after a user clicks on a tooltip and types in a new value for a control. Override this if
//  you've changed the default tooltip display (translating a linear value to logarithmic, for instance)
//  in GetTooltipText().
//-------------------------------------------------------------------------------
@Override
public void EditComponentValue( VoltageComponent component, double newValue, String newText )
{
   //[user-EditComponentValue]   Add your own code here



   //[/user-EditComponentValue]
   super.EditComponentValue( component, newValue, newText );
}


//-------------------------------------------------------------------------------
//  public void OnUndoRedo( String undoType, double newValue, Object optionalObject )

//  If you've created custom undo events via calls to CreateUndoEvent, you'll need to
//  process them in this function when they get triggered by undo/redo actions.
//-------------------------------------------------------------------------------
@Override
public void OnUndoRedo( String undoType, double newValue, Object optionalObject )
{
   //[user-OnUndoRedo]   Add your own code here



   //[/user-OnUndoRedo]
}


//-------------------------------------------------------------------------------
//  public byte[] GetStateInformation()

//  Gets called when the module's state gets saved, typically when the user saves a preset with
//  this module in it. Voltage Modular will automatically save the states of knobs, sliders, etc.,
//  but if you have any custom state information you need to save, return it from this function.
//-------------------------------------------------------------------------------
@Override
public byte[] GetStateInformation()
{
   //[user-GetStateInformation]   Add your own code here



   return null;
   //[/user-GetStateInformation]
}


//-------------------------------------------------------------------------------
//  public void SetStateInformation(byte[] stateInfo)

//  Gets called when this module's state is getting restored, typically when a user opens a preset with
//  this module in it. The stateInfo parameter will contain whatever custom data you stored in GetStateInformation().
//-------------------------------------------------------------------------------
@Override
public void SetStateInformation(byte[] stateInfo)
{
   //[user-SetStateInformation]   Add your own code here



   //[/user-SetStateInformation]
}


//-------------------------------------------------------------------------------
//  public byte[] GetStateInformationForVariations()

//  Gets called when a user saves a variation with this module in it.
//  Voltage Modular will automatically save the states of knobs, sliders, etc.,
//  but if you have any custom state information you need to save, return it from this function.
//-------------------------------------------------------------------------------
@Override
public byte[] GetStateInformationForVariations()
{
   //[user-GetStateInformationForVariations]   Add your own code here



   return GetStateInformation();
   //[/user-GetStateInformationForVariations]
}


//-------------------------------------------------------------------------------
//  public void SetStateInformationForVariations(byte[] stateInfo)

//  Gets called when a user loads a variation with this module in it.
//  The stateInfo parameter will contain whatever custom data you stored in GetStateInformationForVariations().
//-------------------------------------------------------------------------------
@Override
public void SetStateInformationForVariations(byte[] stateInfo)
{
   //[user-SetStateInformationForVariations]   Add your own code here
   SetStateInformation(stateInfo);



   //[/user-SetStateInformationForVariations]
}


// Auto-generated variables
private VoltageCurve curve2;
private VoltageCurve curve1;
private VoltageLabel textLabel4;
private VoltageAudioJack outputJackBlue;
private VoltageLabel textLabel3;
private VoltageAudioJack outputJackWhite;
private VoltageSwitch switchTPDF;
private VoltageLabel textLabel2;
private VoltageLabel textLabel1;


//[user-code-and-variables]    Add your own variables and functions here


// Constants

private final double TRIANGULAR_MULT = 0.5;
private final double RECTANGULAR_MULT = 1.0;

// Variables

private boolean triangularDistribution;

private int displaySignalBitDepth;

private boolean stereoNoise;

private double previousBlueNoise;

private double noise1Multiplier;
private double noise2Multiplier;

// Objects

protected NoiseSource noiseSource = new NoiseSource();


// Functions

void ReadDensityFunctionSwitch (double profile)
{
   if (profile > 0.5)
   {
      triangularDistribution = true;
      noise1Multiplier = TRIANGULAR_MULT;
      noise2Multiplier = TRIANGULAR_MULT;
   }
   else
   {
      triangularDistribution = false;
      noise1Multiplier = RECTANGULAR_MULT;
      noise2Multiplier = 0.0;
   }
}

double GetTriangularProbabilityDensityFunction()
{
   return (noise1Multiplier * noiseSource.GetWhiteNoise())  -
          (noise2Multiplier * noiseSource.GetWhiteNoise());
}

double GetBlueNoiseValue ()
{
   double currentValue;
   double outputValue;
   
   currentValue = GetTriangularProbabilityDensityFunction();
   outputValue = (currentValue - previousBlueNoise) * 0.5;
   previousBlueNoise = currentValue;
   
   return (outputValue);      
}




//[/user-code-and-variables]
}

 